#include "stdafx.h"
#include "Config.h"
#include "Menu.h"

MSXML2::IXMLDOMDocumentPtr cfgDoc;
MSXML2::IXMLDOMElementPtr cfgRoot;

LPWSTR sideText;
int sideTextLength;

int def_sideOffset;//32
int def_blankWidth;//8
int def_blankHeight;//4
int def_captionWidth;//23
int def_gradLevel; //1
int def_largeIconSize; //32
int def_smallIconSize; //24

void Config_Load() {
	CoInitialize(NULL);
	cfgDoc.CreateInstance(__uuidof(MSXML2::DOMDocument30));
	cfgDoc->load(L"Menu.xml");
	cfgRoot = cfgDoc->documentElement;

	_bstr_t bstr;
	bstr = cfgRoot->attributes->getNamedItem(L"text")->text;
	sideTextLength = lstrlen(bstr);
	sideText = (LPWSTR)malloc(sizeof(LPWSTR) * sideTextLength);
	lstrcpy(sideText, bstr);
	//SysFreeString(bstr);
	
	bstr = cfgRoot->attributes->getNamedItem(L"sideOffset")->text;
	def_sideOffset = _wtoi(bstr);
	//SysFreeString(bstr);
	bstr = cfgRoot->attributes->getNamedItem(L"blankWidth")->text;
	def_blankWidth = _wtoi(bstr);
	//SysFreeString(bstr);
	bstr = cfgRoot->attributes->getNamedItem(L"blankHeight")->text;
	def_blankHeight = _wtoi(bstr);
	//SysFreeString(bstr);
	bstr = cfgRoot->attributes->getNamedItem(L"captionWidth")->text;
	def_captionWidth = _wtoi(bstr);
	//SysFreeString(bstr);
	bstr = cfgRoot->attributes->getNamedItem(L"gradLevel")->text;
	def_gradLevel = _wtoi(bstr);
	//SysFreeString(bstr);
	bstr = cfgRoot->attributes->getNamedItem(L"def_largeIconSize")->text;
	def_largeIconSize = _wtoi(bstr);
	//SysFreeString(bstr);
	bstr = cfgRoot->attributes->getNamedItem(L"def_smallIconSize")->text;
	def_smallIconSize = _wtoi(bstr);
	//SysFreeString(bstr);
}

void Config_Unload() {
	free(sideText);
	cfgRoot.Release();
	cfgDoc.Release();
	CoUninitialize();
}

MSXML2::IXMLDOMElementPtr Config_Root() {
	return cfgRoot;
}

LPWSTR Config_GetSideText() {
	return sideText;
}

int Config_GetSideTextLength() {
	return sideTextLength;
}

bool Config_GetButton(LPWSTR* buttonName) {
	_bstr_t bstr;

	bstr = cfgRoot->attributes->getNamedItem(L"button")->text;
	*buttonName = (LPWSTR)malloc(sizeof(LPWSTR) * lstrlen(bstr));
	lstrcpy(*buttonName, bstr);
	//SysFreeString(bstr);

	bstr = cfgRoot->attributes->getNamedItem(L"tray")->text;
	if (lstrcmp((LPWSTR)bstr, L"1") == 0) {
		return true;
	}
	else {
		return false;
	}
	//SysFreeString(bstr);
}

void Config_GetVisualSettings(int* sideOffset, int* blankWidth, int* blankHeight, int* captionWidth, int* gradLevel) {
	*sideOffset = def_sideOffset;
	*blankWidth = def_blankWidth;
	*blankHeight = def_blankHeight;
	*captionWidth = def_captionWidth;
	*gradLevel = def_gradLevel;
}

int Config_GetDefIconSize(bool isTopMenu){
	return isTopMenu ? def_largeIconSize : def_smallIconSize;
}
