#include "stdafx.h"
#include "Menu.h"
#include "Config.h"


#define DPI_SCALE(in) in * DPI / STANDARD_DPI

int sideOffset;
int blankWidth;
int blankHeight;
int captionWidth;
int gradLevel;

int textHeight;
int DPI;

void CalcScale() {
	HDC hdc = GetDC(NULL);
	DPI = GetDeviceCaps(hdc, LOGPIXELSX);

	Config_GetVisualSettings(&sideOffset, &blankWidth, &blankHeight, &captionWidth, &gradLevel);

	sideOffset = DPI_SCALE(sideOffset);
	blankWidth = DPI_SCALE(blankWidth);
	blankHeight = DPI_SCALE(blankHeight);
	captionWidth = DPI_SCALE(captionWidth);

	SIZE size;
	GetTextExtentPoint32(hdc, L"T", lstrlen(L"T"), &size);
	textHeight = DPI_SCALE(size.cy);
}

void DrawGradientV(HDC hdc, COLORREF co1, COLORREF co2, RECT& DrawRect)
{
	int r = GetRValue(co1);
	int g = GetGValue(co1);
	int b = GetBValue(co1);

	int r2 = GetRValue(co2);
	int g2 = GetGValue(co2);
	int b2 = GetBValue(co2);

	//,
	int DrawRectWidth = DrawRect.right - DrawRect.left;
	int DrawRectHeight = DrawRect.bottom - DrawRect.top;

	if (DrawRectWidth <= 0)
		return;

	//ʼrect
	RECT rect = { 0,0,DrawRectWidth, gradLevel};

	//׼GDI
	HDC hMemDC = CreateCompatibleDC(hdc);                //ڴDC
	HBITMAP hBitmap = ::CreateCompatibleBitmap(hdc, DrawRectWidth, DrawRectHeight);//λͼ
	SelectObject(hMemDC, hBitmap);        //λͼѡڴDC
	HBRUSH hbr;


	for (int i = DrawRectHeight; i > 0; i -= gradLevel)
	{
		//ˢ
		hbr = CreateSolidBrush(RGB(r, g, b));
		FillRect(hMemDC, &rect, hbr);
		DeleteObject(hbr);

		//ıСλ
		rect.top += gradLevel;
		rect.bottom += gradLevel;

		//жСǷ񳬽
		if (rect.bottom > DrawRect.bottom)
			rect.bottom = DrawRect.bottom;

		//ıɫ
		r += (r2 - r + i / 2) / i * gradLevel;
		g += (g2 - g + i / 2) / i * gradLevel;
		b += (b2 - b + i / 2) / i * gradLevel;
	}

	//ڴDCӳ䵽ĻDC
	BitBlt(hdc, DrawRect.left, DrawRect.top, DrawRectWidth, DrawRectHeight, hMemDC, 0, 0, SRCCOPY);

	//ɾ
	DeleteDC(hMemDC);
	DeleteObject(hBitmap);
}

LRESULT MeasureItem(HWND hWnd, WPARAM wParam, LPMEASUREITEMSTRUCT lpmis) {
	if (wParam != 0)
		return 0;	//Not a menu

	MENUTAG* menuTag = (MENUTAG*)lpmis->itemData;

	if (menuTag == nullptr) {
		lpmis->itemWidth = 32;
		lpmis->itemHeight = 6;
		return 0;
	}

	SIZE size;
	HDC hDC = GetDC(hWnd);
	GetTextExtentPoint32(hDC, menuTag->text, lstrlen(menuTag->text), &size);

	if (menuTag->isTopMenu) {
		lpmis->itemWidth = sideOffset + blankWidth + DPI_SCALE(menuTag->iconSize) + blankWidth + size.cx * 2 + +blankWidth;
		lpmis->itemHeight = blankHeight + DPI_SCALE(menuTag->iconSize) + blankHeight;
	}
	else {
		lpmis->itemWidth = blankWidth + DPI_SCALE(menuTag->iconSize) + blankWidth + size.cx * 2 + +blankWidth;
		lpmis->itemHeight = blankHeight + DPI_SCALE(menuTag->iconSize) + blankHeight;
	}

	return 0;
}

LRESULT DrawItem(HWND hWnd, WPARAM wParam, LPDRAWITEMSTRUCT lpdis) {
	if (wParam != 0)
		return 0;	//Not a menu

	MENUTAG* menuTag = (MENUTAG*)lpdis->itemData;

	RECT myRect;


	memcpy(&myRect, &(lpdis->rcItem), sizeof(RECT));
	if (menuTag == nullptr) {
		//Splitor	
		myRect.bottom -= 2;
		myRect.top += 3;
		if (lpdis->itemID == SPLITTER_TOPLEVEL)
			myRect.left += sideOffset + blankWidth;

		FillRect(lpdis->hDC, &myRect, CreateSolidBrush(RGB(191, 191, 191)));
	}
	else
	{
		//Menu Item
		if (menuTag->isTopMenu) {
			GetClipBox(lpdis->hDC, &myRect);
			myRect.right = sideOffset;
			DrawGradientV(lpdis->hDC, RGB(0, 0, 122), RGB(0, 0, 245), myRect);

			if (sideOffset > 0) {
				GetClipBox(lpdis->hDC, &myRect);
				HFONT hfont = CreateFont(captionWidth, 0, 900, 900, FW_BOLD,
					0, 0, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS,
					CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
					DEFAULT_PITCH, L"Arial");
				HFONT pOldFont = (HFONT)SelectObject(lpdis->hDC, hfont);

				COLORREF oldColor = GetTextColor(lpdis->hDC);
				SetTextColor(lpdis->hDC, RGB(255, 255, 255));
				SetBkMode(lpdis->hDC, TRANSPARENT);
				TextOut(lpdis->hDC, myRect.left + (sideOffset - captionWidth) / 2, myRect.bottom - (sideOffset - captionWidth), Config_GetSideText(), Config_GetSideTextLength());
				SetTextColor(lpdis->hDC, oldColor);
				SelectObject(lpdis->hDC, pOldFont);
			}


			memcpy(&myRect, &(lpdis->rcItem), sizeof(RECT));
			myRect.left += sideOffset;
		}

		if (lpdis->itemState & ODS_SELECTED) {
			SetTextColor(lpdis->hDC, RGB(255, 255, 255));
			FillRect(lpdis->hDC, &myRect, CreateSolidBrush(GetSysColor(COLOR_MENUHILIGHT)));
		}
		else {
			SetTextColor(lpdis->hDC, RGB(0, 0, 0));
			FillRect(lpdis->hDC, &myRect, CreateSolidBrush(GetSysColor(COLOR_MENU)));
		}

		SetBkMode(lpdis->hDC, TRANSPARENT);

		DrawIconEx(lpdis->hDC, blankWidth + myRect.left, myRect.top + blankHeight, menuTag->icon, DPI_SCALE(menuTag->iconSize), DPI_SCALE(menuTag->iconSize), 0, NULL, DI_NORMAL);
		//DrawIcon(lpdis->hDC,  BLANKWIDTH + myRect.left, myRect.top + BLANKWIDTH, menuTag->icon);
		TextOut(lpdis->hDC, blankWidth + DPI_SCALE(menuTag->iconSize) + blankWidth + myRect.left, myRect.top + (blankHeight + DPI_SCALE(menuTag->iconSize) + blankHeight - textHeight) / 2, menuTag->text, lstrlen(menuTag->text));
	}


	return 0;
}