// dllmain.cpp : Defines the entry point for the DLL application.
#include "stdafx.h"
#include "Menu.h"
#include "Config.h"

static HMODULE gLibModule = 0;
static LONG_PTR gOldWndProc = 0;
static HWND gHwnd = 0;




static DWORD WINAPI FreeSelf(LPVOID param) {
	FreeLibraryAndExitThread(gLibModule, EXIT_SUCCESS);
}

static void RestoreWndProc() {
	if (gOldWndProc != 0) {
		SetWindowLongPtr(gHwnd, GWLP_WNDPROC, gOldWndProc);
	}
}

void CloseBackground() {
	RestoreWndProc();
	CloseHandle(CreateThread(nullptr, 0, (LPTHREAD_START_ROUTINE)FreeSelf, nullptr, 0, nullptr));
}

LRESULT CALLBACK MyWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch (uMsg) {
	case WM_NCHITTEST:
		return HTCLIENT;
	case WM_CONTEXTMENU:
		Menu_Show(hwnd, LOWORD(lParam), HIWORD(lParam));
		return 0;
	case WM_MENUCOMMAND: 
		Menu_Action((HMENU)lParam, LOWORD(wParam));
		return 0;
	case WM_MEASUREITEM:
		return MeasureItem(hwnd, wParam, (LPMEASUREITEMSTRUCT)lParam);

	case WM_MENU98:
		if (wParam == EXITHOST)
			CloseBackground();
		return 0;

	case WM_DRAWITEM:
		return DrawItem(hwnd, wParam, (LPDRAWITEMSTRUCT)lParam);
	}
	return WNDPROC(gOldWndProc)(hwnd, uMsg, wParam, lParam);
}

HWND GetButtonHWND() {
	HWND hWnd;
	LPWSTR buttonName;
	if (Config_GetButton(&buttonName)) {
		hWnd = FindWindow(L"Shell_TrayWnd", nullptr);
		hWnd = FindWindowEx(hWnd, 0, buttonName, nullptr);
	}
	else {
		hWnd = FindWindow(buttonName, nullptr);
	}
	free(buttonName);
	return hWnd;
}

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		gLibModule = hModule;

		Config_Load();

		gHwnd = GetButtonHWND();
		if (IsWindow(gHwnd)) {
			gOldWndProc = GetWindowLongPtr(gHwnd, GWLP_WNDPROC);
			if (gOldWndProc != 0)
				SetWindowLongPtr(gHwnd, GWLP_WNDPROC, (LONG_PTR)&MyWndProc);
		}
		
		Menu_Init();
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		Menu_Destroy();
		Config_Unload();
		RestoreWndProc();
		break;
	}
	return TRUE;
}
