#include "stdafx.h"
#include "Config.h"


void GetProcessFilePath(IN HANDLE hProcess, OUT LPWSTR sFilePath)
{
	TCHAR tsFileDosPath[MAX_PATH + 1];
	ZeroMemory(tsFileDosPath, sizeof(TCHAR)*(MAX_PATH + 1));
	if (0 == GetProcessImageFileName(hProcess, tsFileDosPath, MAX_PATH + 1))
	{
		return;
	}

	UINT uiLen = GetLogicalDriveStrings(0, NULL);
	if (0 == uiLen)
	{
		return;
	}

	PTSTR pLogicDriveString = new TCHAR[uiLen + 1];
	ZeroMemory(pLogicDriveString, uiLen + 1);
	uiLen = GetLogicalDriveStrings(uiLen, pLogicDriveString);
	if (0 == uiLen)
	{
		delete[]pLogicDriveString;
		return;
	}

	TCHAR szDrive[3] = TEXT(" :");
	PTSTR pDosDriveName = new TCHAR[MAX_PATH];
	PTSTR pLogicIndex = pLogicDriveString;

	do
	{
		szDrive[0] = *pLogicIndex;
		uiLen = QueryDosDevice(szDrive, pDosDriveName, MAX_PATH);
		if (0 == uiLen)
		{
			if (ERROR_INSUFFICIENT_BUFFER != GetLastError())
			{
				break;
			}

			delete[]pDosDriveName;
			pDosDriveName = new TCHAR[uiLen + 1];
			uiLen = QueryDosDevice(szDrive, pDosDriveName, uiLen + 1);
			if (0 == uiLen)
			{
				break;
			}
		}

		uiLen = _tcslen(pDosDriveName);
		if (0 == _tcsnicmp(tsFileDosPath, pDosDriveName, uiLen))
		{
			wsprintf(sFilePath, L"%s%s", szDrive, tsFileDosPath + uiLen);
			break;
		}

		while (*pLogicIndex++);
	} while (*pLogicIndex);

	delete[]pLogicDriveString;
	delete[]pDosDriveName;
}

LPWSTR GetConfigFilePath() {
	DWORD ProcessID;
	HWND hWnd = FindWindow(L"Shell_TrayWnd", nullptr);
	GetWindowThreadProcessId(hWnd, &ProcessID);
	LPWSTR path = (LPWSTR)malloc(sizeof(wchar_t)*MAX_PATH);
	HANDLE hP = OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, ProcessID);
	GetProcessFilePath(hP, path);
	CloseHandle(hP);
	int fileNameLength = GetFileTitle(path, nullptr, 0);
	lstrcpy(path + lstrlen(path) - fileNameLength + 1, L"menu.xml");
	return path;
}

HWND Config_GetButtonHandle() {
	LPWSTR path = GetConfigFilePath();
	LPWSTR buttonName;
	HWND hWnd;
	
	Config_Load(path);

	if (Config_GetButton(&buttonName)) {
		hWnd = FindWindow(L"Shell_TrayWnd", nullptr);
		hWnd = FindWindowEx(hWnd, 0, buttonName, nullptr);
	}
	else {
		hWnd = FindWindow(buttonName, nullptr);
	}

	free(buttonName);
	Config_Unload();
	free(path);

	return hWnd;
}