#include "stdafx.h"
#include "SysVer.h"
#include <shlobj.h>
#include <shlwapi.h>

int nMajorVersion, nMinorVersion, nBuildVersion, nReviVersion;

bool SysVer_isHighVer() {
	if (nMajorVersion == 6 && nMajorVersion == 3) {
		return true;
	}
	else if (nMajorVersion >= 10) {
		return true;
	}

	return false;
}

int SysVer_GetMajorVer() {
	return nMajorVersion;
}

int SysVer_GetMinorVer() {
	return nMinorVersion;
}

bool GetWindowsVersion()
{
	TCHAR szDLLName[MAX_PATH] = { 0 };
	HRESULT hr = SHGetFolderPath(NULL, CSIDL_SYSTEM, NULL, SHGFP_TYPE_CURRENT, szDLLName);
	if (SUCCEEDED(hr) && PathAppend(szDLLName, _T("kernel32.dll")))
	{
		DWORD dwVerInfoSize = GetFileVersionInfoSize(szDLLName, NULL);
		if (dwVerInfoSize > 0) {
			LPVOID pvVerInfoData = (LPVOID)new BYTE[dwVerInfoSize];
			if (GetFileVersionInfo(szDLLName, 0, dwVerInfoSize, pvVerInfoData)) {
				UINT ulLength = 0;
				VS_FIXEDFILEINFO* pVsInfo = NULL;
				if (VerQueryValue(pvVerInfoData, _T("\\"), (LPVOID *)&pVsInfo, &ulLength))
				{
					nMajorVersion = HIWORD(pVsInfo->dwProductVersionMS);
					nMinorVersion = LOWORD(pVsInfo->dwProductVersionMS);
					nBuildVersion = HIWORD(pVsInfo->dwProductVersionLS);
					nReviVersion = LOWORD(pVsInfo->dwProductVersionLS);
					delete[] pvVerInfoData;
					return true;
				}
			}
			delete[] pvVerInfoData;
		}
	}
	return false;
}

enOsInfo SysVer_GetOsInfo()
{

	if (GetWindowsVersion())
	{
		switch (nMajorVersion) {
		case 10:
			return OS_WIN10;
		case 6:
			switch (nMinorVersion) {
			case 0:
				return OS_WIN_VISTA;
			case 1:
				return OS_WIN7;
			case 2:
				return OS_WIN8;
			case 3:
				return OS_WIN8_1;
			default:
				return OS_UNKNOWN;
			}
		case 5:
			switch (nMinorVersion) {
			case 0:
				return OS_WIN_2000;
			case 1:
				return OS_WIN_XP;
			case 2:
				return OS_WIN_2003;
			default:
				return OS_UNKNOWN;
			}
		default:
			return OS_UNKNOWN;
		}
	}
	return OS_UNKNOWN;
}